% --------------------------------------------------------------------------
%   FILE:       ATTENDING.PL
%   AUTHOR:     Tim Duncan, (Modified Tom Khabaza, May 1988)
%   UPDATED:    Wed Aug 12 12:46:41 BST 1987
%   PURPOSE:    Loads all the files making up ATTENDING.
% --------------------------------------------------------------------------

:- op(100,fx,*).
:- op(100,xfy,:).

:- library(record), library(unknown), unknown(_,fail).

/* The following two clauses are to increase efficiency
   Average time for gencrit/1 over 10 trials:
   CPU = 66.51 secs
   GC  =  2.03 secs
*/
:- prolog_no_clauses.           % textual form not kept
:- prolog_syspredicates(on).    % predicates treated as constants


/* The following two clauses return the system to normal.
   Average time for gencrit/1 over 6 trials:
   CPU = 155.51 secs
   GC  =  28.53 secs

:- prolog_clauses.
:- prolog_syspredicates(off).
*/


:- library('attending/action').
:- library('attending/anes_net').
:- library('attending/descript').
:- library('attending/environ').
:- library('attending/func').
:- library('attending/gencrit').
:- library('attending/menu').
:- library('attending/pat').
:- library('attending/pmf').
:- library('attending/prose').
:- library('attending/risk').
:- library('attending/runoff').
:- library('attending/textgen').
:- library('attending/toplevel').
:- library('attending/utility').


/* The next command forces a garbage collection, and
   then locks the heap, so that the garbage collector
   doesn't waste time trying to reclaim predicates!
*/

:- trimcore, prolog_lock_code.
